<?php
// $Id: views_handler_filter_heartbeat_access.inc,v 1.1.2.2.2.2 2009/08/10 20:27:42 stalski Exp $

/**
 * Filter by language
 */
class views_handler_filter_heartbeat_access extends views_handler_filter_numeric {

  /*public $whoisuser = array(
    0 => 'Acting user',
    1 => 'Requested user (from url)'
  );*/

  function construct() {
    parent::construct();
    $this->value_value = t('Are restricted to access type');
    //$this->value['whoisuser'] = 0;
    $this->value['access'] = 0;
  }

  /**
   * Implementation override option_definition
   * Information about options for all kinds of purposes will be held here.
   *
   * @return array options definition
   */
  function option_definition() {
    $options = parent::option_definition();
    return $options;
  }

  /**
   * Set default values for the heartbeat access filter.
   */
  function options(&$options) {
    parent::options($options);
    $options['value']['access'] = array();
    //$options['value']['whoisuser'] = array();
  }

  /**
   * Definition of available operators
   * Override the parent method
   *
   * @return array of operators
   */
  function operators() {
    $operators = array(
      '=' => array(
        'title' => t('Is equal to'),
        'method' => 'op_simple',
        'short' => t('='),
        'values' => 1,
      ),
      '!=' => array(
        'title' => t('Is not equal to'),
        'method' => 'op_simple',
        'short' => t('!='),
        'values' => 1,
      )
    );
    // if the definition allows for the empty operator, add it.
    if (!empty($this->definition['allow empty'])) {
      $operators += array(
        'empty' => array(
          'title' => t('Is empty (NULL)'),
          'method' => 'op_empty',
          'short' => t('empty'),
          'values' => 0,
        ),
        'not empty' => array(
          'title' => t('Is not empty (NULL)'),
          'method' => 'op_empty',
          'short' => t('not empty'),
          'values' => 0,
        ),
      );
    }
    return $operators;
  }

  /**
   * Display the filter on the administrative summary.
   * After selecting, let the builder of the view
   * know what he selected
   *
   * @return human title for the access type
   */
  function admin_summary() {
    $options = _heartbeat_access_type_options();
    $key =  (!empty($this->value['access']) ? $this->value['access'] : 'PublicHeartbeat');
    $return = $options[$key];

    /*if (!empty($this->value['whoisuser']) && !empty($this->whoisuser[$this->value['whoisuser']])) {
      $return .=  ': '. $this->whoisuser[$this->value['whoisuser']];
    }*/
    return $return;
  }

  /**
   * Adding things to query object
   *
   */
  function query() {
    global $user;
    /*
    if($this->value['whoisuser'] == 1) {
      if(arg(0) == 'heartbeat' && arg(1) == 'user' && is_numeric(arg(2)) ) {
        $uid = arg(2);
      }
      elseif(arg(0) == 'user' && is_numeric(arg(1)) && arg(2) != 'edit') {
        $uid = arg(1);
      }
      else {
        $uid = $user->uid;
      }
    }
    else {
      $uid = $user->uid;
    }*/
    $uid = $user->uid;

    $this->ensure_my_table();
    $info = $this->operators();

    $access = $this->value['access'];
    $types = _heartbeat_access_type_options();
    if (isset($types[$access])) {
    	$heartbeataccess = new $access();
      // Get extra sql part for this access state
    	$heartbeataccess->addViewQuery($this);
    }
  }

  /**
   * Add a type selector to the value form
   */
  function value_form(&$form, &$form_state) {
    if (empty($form_state['exposed'])) {
      $form['value']['access'] = array(
        '#type' => 'radios',
        '#title' => t('Access type'),
        '#options' => _heartbeat_access_type_options(),
        '#default_value' => !empty($this->value['access']) ? $this->value['access'] : 'PublicHeartbeat',
      );
      /*$form['value']['whoisuser'] = array(
        '#type' => 'radios',
        '#title' => t('Who is targetuser'),
        '#options' => $this->whoisuser,
        '#default_value' => !empty($this->value['whoisuser']) ? $this->value['whoisuser'] : 0,
      );*/
    }
    parent::value_form($form, $form_state);
  }

}